﻿namespace VL.Vector.Core
{
    public class GenericVector2<T> : Vector<T, V2>
    {
        public GenericVector2(T X, T Y) : base(X, Y) { }
        public T X => Data[0];
        public T Y => Data[1];
    }

    public class GenericVector3<T> : Vector<T, V3>
    {
        public GenericVector3(T X, T Y, T Z) : base(X, Y, Z) { }
        public T X => Data[0];
        public T Y => Data[1];
        public T Z => Data[2];
    }

    public class GenericVector4<T> : Vector<T, V4>
    {
        public GenericVector4(T X, T Y, T Z, T W) : base(X, Y, Z, W) { }
        public T X => Data[0];
        public T Y => Data[1];
        public T Z => Data[2];
        public T W => Data[3];
    }
}
